#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "oentry.h"



// default contructor
//PRE: nothing
//POST: initalizes i to -1 
oentry::oentry()
{
  i=-1;
}
	
//another constructor
//PRE: given i
//POST: initalizes i to pos
oentry::oentry(int pos)
{
  i=pos;
}

//copy constructor
//PRE:	none
//POST:	A new clentry is created with the same
// parameters as original
oentry::oentry(const oentry& original)
{
  copy(original);
}

//destructor
//PRE: a clentry exists
//POST: it is destroyed
oentry::~oentry()
{
  //clist.clear();
}

//Member operator function
//PRE:	none
//POST:	the contents of otherCLEntry are copied into this clentry
const oentry& oentry::operator=(const oentry& otherOEntry)
{
  if (&otherOEntry != this)
    {
      copy(otherOEntry);
    }
  return *this;
}
	
//make a copy of another clentry
//PRE:	none
//POST:	the contents of the other clentry are 
//		copied into this one
void oentry::copy(const oentry& otherOEntry)
{
  i = otherOEntry.i;
  clist = otherOEntry.clist;
}

//the comparison operator needs to be overloaded
bool oentry::operator== (const oentry& right) const
{
  if(i == right.i)
    {
      cout << "Just classified this oentry with i " << i << " to be popped\n";
      return true;
    }
}

//get rep
//PRE: none
//POST:	rep is returned
int oentry::getI()
{
  return i;
}
	
//get ww of clentry
//PRE: none
//POST:	ww returned	
list<clentry>::iterator oentry::getCLIST_IT()
{
  list<clentry>::iterator cl_it = clist.begin();
  return cl_it;
}

//to check if we have traversed to the end of our clist
//PRE:none
//POST: true if we are at the end, false otherwise
list<clentry>::iterator oentry::at_end()
{
  return clist.end();
}


//to push something onto the clist
//PRE:given clentry
//POST: clentry is pushed onto clist
void oentry::push_cl(const clentry& cl)
{
  clist.push_back(cl);
}
		

//for debugging purposes, prints oentry
void oentry::print()
{
  cout << "The oentry with i: " << i
       << "\n clist: \n";

  int z =1;
  list<clentry>::iterator br;
  for(br=clist.begin(); br != clist.end(); br++)
    {
      cout << z << ") ";
      (*br).print_it();
      cout << endl;
      z++;
    }
}

bool oentry::empty()
{
  return clist.empty();
}
