#include "Stack.h"




//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
Stack::Stack(ReadInput * R){
//Initialize
    Number = 0;
    NumMarked = 0;
    NumberM = 0;
    elements = new T_stackelem[MaxN];
    PrevInStack = new int[MaxN];
    memset(PrevInStack, 0, MaxN*sizeof(int));
    Input = R;
};
//EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE


//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
Stack::~Stack(){
//Initialize
    delete []elements;
    delete [] PrevInStack;
};
//EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE



//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
void Stack::Remove(int a){
    //Removes $a from stack
           // printf("removing %d \n",a);



    elements[elements[a].prev].next = elements[a].next;
    elements[elements[a].next].prev = elements[a].prev;

    RemoveM(a);


    if (Number == a)
        Number = elements[a].prev;


        //printf("it was in the middle of %d, %d \n", elements[a].prev,elements[a].next);



};
//EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE




//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
void Stack::RemoveM(int a){
    //Removes $a from stack
           //printf("removingN %d \n",a);



    elements[elements[a].prevM].nextM = elements[a].nextM;
    elements[elements[a].nextM].prevM = elements[a].prevM;

    if (NumberM == a)
        NumberM = elements[a].prevM;



};
//EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE




//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
void Stack::Push(int a){
//Push element 'a' in the stack
//Number start form 1 to $Number
      // printf("pushing %d \n",a);

       //printf("on top is %d , lastM is %d \n", Number, NumberM);

    elements[a].prev = Number;
    elements[a].next = 0;
    elements[a].prevM = NumberM;
    elements[a].nextM = 0;
    elements[a].MarkB = 0;
    elements[a].MarkP = 0;
    elements[a].MarkN = 0;

    elements[Number].next = a;

    Number = a;

    elements[NumberM].nextM = a;
    NumberM = a;



};
//EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE



//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
int Stack::Top(){
          // printf("Top stack %d \n",Number);



  return Number;


};
//EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE


//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
void Stack::putMarkB(int a){
    elements[a].MarkB = 1;
        //printf("Marking B %d \n",a);



    NumMarked++;


};

void Stack::putMarkP(int a){
    elements[a].MarkP = 1;
      // printf("Marking P %d \n",a);



    NumMarked++;

};

void Stack::putMarkN(int a){
    elements[a].MarkN = 1;
          // printf("Marking N %d \n",a);



    NumMarked++;

};
//EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE


//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
int Stack::markB(int a){
    return elements[a].MarkB;
};

int Stack::markP(int a){
    return elements[a].MarkP;
};

int Stack::markN(int a){
    return elements[a].MarkN;
};
//EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE





//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
int Stack::Pred(int a){    //The elements of top of $a on the stack
    return elements[a].prev;
}
//EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE



//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
void Stack::Add(int a){
    int b, e;
    if (Add(a, b, e))
        printf("Found Close Region [%d, %d]\n",b,e); fflush(stdout);



}




int Stack::Add(int a, int&b, int &e){
//Adds a base $a to the stack and probably pushes it or pops something or mark some elements...

    PrevInStack[a] = Top();

    if (a < Input->BasePair(a)){          // a is the starting pair
        Push(a);

        return 0;
    };

    if (Input->BasePair(a) <= 0)         // a is unpaired
        return 0;

    int pa = Input->BasePair(a);

    putMarkB(pa);

    if (Top() == pa)    //bp(a) is on top of the stack
        if (!markP(pa)){       // [pa, a] is a closed region

        Remove(pa);
        //Add-To-Tree [pa,a]
        b = pa; e = a;
        return 1;
        }
    else{
      if ( markP(Pred(pa)) && markB(Pred(pa)) && !markN(Pred(pa)) ) {
//if ( markP(Pred(pa)) && markB(Pred(pa)) && !markN(Pred(pa)) && (pa == Pred(a)) {

        Remove(pa);
        int h = Top();
        Remove(h);
        //Add-To-Tree [h,a]
        b = h; e = a;
        return 1;

    };


    }


    putMarkP(pa);
    int top = NumberM;
        //printf("STARt Searching the stack from top = %d to mark N \n", top);
    while  ( top > pa) {

        putMarkP(top);
        putMarkN(top);
        if (markP(top) && markB(top) && markN(top))
            Remove(top);

        else if (markN(top))
            RemoveM(top);

        top = NumberM;
    };

        //printf("ENd Searching the stack from top to mark N \n");


    if (markP(pa) && markB(pa) && markN(pa))
        Remove(pa);


    return 0;


}
//EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE



