#ifndef STACK_H
#define STACK_H

#include "Input.h"

class Stack
{ 
 private: 

  T_stackelem* elements; 
  int Number;  //The Stack Pointer 
  int NumberM; //The stack Pointer for those elemtn that have P&N&!B
 
 public:  

  int * PrevInStack;	//The top element on the stack when you put this element
  int NumMarked; 
  ReadInput * Input;

  Stack(ReadInput * R);
  ~Stack();
 
  void Add(int a);					//Adds a pair $a to the stack
  int Add(int a, int&b, int &e);		//Adds and if  a closed region is found the function returs 1 and [b,e] 
  void Remove(int a);					//To Remove an element from the stack
  void RemoveM(int a);				//update prevM and nextM
  void Push(int a);					//Push and element on the stack
  int Top();							// The element on top of the stack
  void putMarkB(int a);				// Marking and element as 'B'
  void putMarkP(int a);
  void putMarkN(int a);
  int markB(int a);					// Has the element mark B?
  int markP(int a); 
  int markN(int a); 
  int Pred(int a);					// The elemnt before $a on the stack

};
#endif

//We have two Linked lists together.  One which keeps track of all elements on the stack and the other which keeps track of all elements of the 
//stack  that have not either P or N. (i.e. P&N&!B does not hold for them)

